routes/web.php
<?php

use App\Http\Controllers\AdresseController;
use App\Http\Controllers\CaracteristiqueController;
use App\Http\Controllers\CategorieProduitController;
use App\Http\Controllers\ClientController;
use App\Http\Controllers\ClimatController;
use App\Http\Controllers\CommandeController;
use App\Http\Controllers\DinosaureController;
use App\Http\Controllers\EnclosController;
use App\Http\Controllers\EnvironnementController;
use App\Http\Controllers\EspeceController;
use App\Http\Controllers\PersonnelController;
use App\Http\Controllers\ProduitController;
use App\Http\Controllers\TaxeController;
use App\Http\Controllers\TypeEnclosController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
//Route::get('/dashboard', function () {
//    return view('dashboard');
//})->middleware(['auth'])->name('dashboard');
//
//require __DIR__.'/auth.php';

Route::get('/admin', function () {
    return view('pages/admin/index');
})->middleware(['auth'])->name('admin.index');

Route::prefix('admin')->middleware(['auth'])->group(function () {
    Route::resource('/personnels', PersonnelController::class);
    Route::resource('/enclos', EnclosController::class);
    Route::resource('/taxes', TaxeController::class);
    Route::resource('/produits', ProduitController::class);
    Route::resource('/categories-produits', CategorieProduitController::class);
    Route::resource('/dinosaures', DinosaureController::class);
    Route::resource('/especes', EspeceController::class);
    Route::resource('/caracteristiques', CaracteristiqueController::class);
    Route::resource('/climats', ClimatController::class);
    Route::resource('/environnements', EnvironnementController::class);
    Route::resource('/types-enclos', TypeEnclosController::class);
    Route::resource('/adresses', AdresseController::class);
//    Route::resource('/clients', ClientController::class);
    Route::get('/clients', [ClientController::class, 'index'])->name('clients.index');
    Route::get('/clients/{client}/edit', [ClientController::class, 'edit'])->name('clients.edit');
    Route::put('/clients/{client}', [ClientController::class, 'update'])->name('clients.update');
    Route::delete('/clients/{client}', [ClientController::class, 'destroy'])->name('clients.destroy');
});

require __DIR__.'/auth.php';

Route::get('/clients/create/{userId}', [ClientController::class, 'create'])->name('clients.create');
Route::post('/clients', [ClientController::class, 'store'])->name('clients.store');
Route::post('/clients/{client}', [ClientController::class, 'store'])->name('clients.show');

Route::post('/adresse', [AdresseController::class, 'store'])->name('adresse.store');
Route::get('/boutique', [CommandeController::class, 'index'])->name('boutique.index');
Route::post('/panier', [CommandeController::class, 'create'])->name('panier.create');
Route::put('/panier', [CommandeController::class, 'store'])->middleware(['auth'])->name('panier.store');

Route::get('/', [DinosaureController::class, 'homepage'])->name('homepage');

app/Models/Enclos.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Enclos extends Model
{
    use HasFactory;

    protected $guarded = ['id'];

    public function dinosaures(){
        return $this->hasMany(Dinosaure::class);
    }

    public function environnements(){
        return $this->belongsToMany(Environnement::class, 'enclos_environnement', 'enclos_id', 'environnement_id')
            ->withTimestamps();
    }

    public function personnels(){
        return $this->belongsToMany(Personnel::class, 'enclos_personnel');
    }

    public function climat(){
        return $this->belongsTo(Climat::class);
    }

    public function typeEnclos(){
        return $this->belongsTo(TypeEnclos::class);
    }
}

app/Http/Controllers/EnclosController.php
<?php

namespace App\Http\Controllers;

use App\Models\Climat;
use App\Models\Dinosaure;
use App\Models\Enclos;
use App\Models\Environnement;
use App\Models\Personnel;
use App\Models\TypeEnclos;
use Illuminate\Http\Request;

class EnclosController extends Controller
{
    public function index() {
        $enclosures = Enclos::with(['personnels', 'dinosaures', 'environnements', 'climat', 'typeEnclos'])
            ->select(['id', 'nom', 'superficie', 'type_enclos_id', 'climat_id'])
            ->get();

        return view('pages/admin/enclos/index', ['enclosures' => $enclosures]);
    }

    public function show($enclosId) {
        $enclosure = Enclos::with(['personnels', 'dinosaures', 'environnements', 'climat', 'typeEnclos'])
            ->select(['id', 'nom', 'superficie', 'type_enclos_id', 'climat_id'])
            ->where('id', $enclosId)
            ->firstOrFail();

        return view('pages/admin/enclos/show', [
            'enclos' => $enclosure
        ]);
    }

    public function create() {
        $dinosaures = Dinosaure::pluck('nom','id');
        $climats = Climat::pluck('nom', 'id');
        $typeEnclos = TypeEnclos::pluck('nom', 'id');
        $environnements = Environnement::all();
        $personnels = Personnel::pluck('nom', 'id');
        return view('pages/admin/enclos/create', [
            'dinosaures' => $dinosaures,
            'climats' => $climats,
            'typeEnclos' => $typeEnclos,
            'environnements' => $environnements,
            'personnels' => $personnels,
        ]);
    }

    public function store(Request $request) {
        $enclos = Enclos::create($request->all());

        if ( isset($request->all()['dinosaures'])) {
            foreach($request->all()['dinosaures'] as $i => $dinosaureId) {
                $dinosaure = Dinosaure::find($dinosaureId);
                $dinosaure->enclos_id = $enclos->id;
                $dinosaure->save();
            }
        }

        foreach($request->all()['superficie-environnement'] as $environnementId => $superficie) {
            if (isset($superficie)) {
                $enclos->environnements()->attach([
                    $environnementId => ['superficie' => $superficie],
                ]);
            }
        }


        if ( isset($request->all()['personnels'])) {
            foreach ($request->all()['personnels'] as $i => $personnelId) {
                $enclos->personnels()->attach([$personnelId]);
            }
        }

        return redirect()->route('enclos.index');
    }

    public function edit(Enclos $enclosId) {
        $enclos = Enclos::find($enclosId);
        return view('pages/admin/caracteristique/edit', [
            'caracteristique' => $enclos
        ]);
    }

    public function update(Request $request, $enclosId) {
        $enclos = Enclos::find($enclosId);
        $enclos->update($request->all());
        return redirect()->route('enclos.index');
    }

    public function destroy($enclosId) {
        $enclos = Enclos::find($enclosId);
        $enclos->delete();
        return redirect()->route('enclos.index');
    }
}

resources/views/pages/admin/enclos/create.blade.php
@extends('layouts.admin-layout')

@section('content')
    <div class="row">
        <div class="col">
            {!! Form::open(["method" => "POST", "route" => 'enclos.store']) !!}
            <label for="nom">Nom de l'enclos</label>
            {!! Form::text("nom", null, ["class" => "form-group form-control"]) !!}
        </div>
        <div>
            <label for="superficie">Superficie de l'enclos</label>
            {!! Form::number("superficie", null, ["class" => "form-group form-control", "step" => 1]) !!}
        </div>
    </div>

    <div class="row">
        <div class="col">
            <div class="input-group mb-3">
                <div class="input-group-prepend">
                    <label for="climat_id" class="input-group-text text-dark">Climat</label>
                </div>
                {!! Form::select("climat_id", $climats, ["class" => "custom-select"]) !!}
            </div>
        </div>
        <div class="col">
            <div class="input-group mb-3">
                <div class="input-group-prepend">
                    <label for="type_enclos_id" class="input-group-text text-dark">Type d'enclos</label>
                </div>
                {!! Form::select("type_enclos_id", $typeEnclos, ["class" => "custom-select"]) !!}
            </div>
        </div>
    </div>
<div class="row">
    <div class="col">
        <div class="input-group mb-3">
            <div class="input-group-prepend">
                <label for="dinosaures[]" class="input-group-text text-dark">Dinosaures</label>
            </div>
            {!! Form::select('dinosaures[]', $dinosaures, ["class" => "custom-select"], ['multiple' => 'multiple']) !!}
        </div>
    </div>
    <div class="col">
        <div class="input-group">
            <div class="input-group-prepend h-100">
                <label for="personnels[]" class="input-group-text text-dark">Membres du personnel</label>
            </div>
            <div class="custom-select">
                {!! Form::select('personnels[]', $personnels, null, ["class" => "custom-select",'multiple']) !!}
            </div>
        </div>
    </div>
</div>

    <div class="row">
        <div class="col">
            @foreach($environnements as $environnement)

            <div class="input-group mb-3" id="select-environments">

                {{ $environnement->nom .' : '}} {!!  Form::number('superficie-environnement['.$environnement->id.']', null, ["class" => "custom-select", "multiple"]) !!}

            </div>
            @endforeach
        </div>
    </div>

<br>
{!! Form::submit("Ajouter", ["class" => "btn btn-success"]) !!}
{!! Form::close() !!}
@endsection

resources/views/pages/admin/enclos/index.blade.php
@extends('layouts.admin-layout')

@section('content')
<table class="table">
    <thead>
        <tr>
            <th>Nom</th>
            <th>Superficie</th>
            <th>Dinosaures</th>
            <th>Employés</th>
            <th>Environnements</th>
            <th>Climat</th>
            <th>Type Enclos</th>
            <th></th>
            <th></th>
            <th></th>
        </tr>
    </thead>
    <tbody>
    @foreach($enclosures as $enclosure)
        <tr>
            <td>{{$enclosure->nom}}</td>
            <td>{{$enclosure->superficie}} km²</td>
            <td>
                @foreach($enclosure->dinosaures as $dinosaure)
                    <a href="{{ route('dinosaures.show', [$dinosaure->id]) }}">{{ $dinosaure->nom }}</a> <br>
                @endforeach
            </td>
            <td>
                @foreach($enclosure->personnels as $employe)
                    <a href="{{ route('personnels.show', [$employe->id]) }}">{{ $employe->prenom.' '.$employe->nom }} <br></a>
                @endforeach
            </td>
            <td>
                @foreach($enclosure->environnements as $environnement)
                    {{ $environnement->nom }} <br>
                @endforeach
            </td>
            <td>{{$enclosure->climat->nom}}</td>
            <td>{{$enclosure->typeEnclos->nom}}</td>
            <td><a href="{{ route('enclos.show', ["enclo" => $enclosure->id]) }}"><i class="fas fa-eye"></i></a></td>
            <td><a href="{{ route('enclos.edit', $enclosure->id) }}"><i class="fas fa-edit"></i></a></td>
            <td>
                {!! Form::open(["method" => "DELETE", "route" => ["enclos.destroy", "enclo" => $enclosure->id]]) !!}
                {{ Form::button('<i class="fas fa-trash"></i>', ['type' => 'submit', 'class' => 'btn'] )  }}
                {!! Form::close() !!}
            </td>
        </tr>
    @endforeach
    </tbody>
</table>

<a href="{{ route('enclos.create') }}" class="btn btn-primary">Ajouter un enclos</a>
@endsection

resources/views/pages/admin/enclos/show.blade.php
@extends('layouts.admin-layout')

@section('content')
    <table class="table">
        <thead class="table-dark">
            <tr>
                <th>Nom</th>
                <th>Superficie</th>
                <th>Dinosaures</th>
                <th>Employés</th>
                <th>Environnements</th>
                <th>Climat</th>
                <th>Type Enclos</th>
                <th></th>
                <th></th>
                <th></th>
            </tr>
        </thead>
        <tbody>
            <tr>
                <td>{{$enclos->nom}}</td>
                <td>{{$enclos->superficie}} km²</td>
                <td>
                    @foreach($enclos->dinosaures as $dinosaure)
                        <a href="{{ route('dinosaures.show', [$dinosaure->id]) }}">{{$dinosaure->nom}}</a><br>
                    @endforeach
                </td>
                <td>
                    @foreach($enclos->personnels as $employe)
                        <a href="{{ route('personnels.show', [$employe->id]) }}">{{$employe->prenom . ' '. $employe->nom}}</a><br>
                    @endforeach
                </td>
                <td>
                    @foreach($enclos->environnements as $environnement)
                        {{ $environnement->nom}}<br>
                    @endforeach
                </td>
                <td>{{$enclos->climat->nom}}</td>
                <td>{{$enclos->typeEnclos->nom}}</td>
                <td><a href="{{ route('enclos.edit', ["enclo" => $enclos->id]) }}"><i class="fas fa-edit"></i></a></td>
                <td>
                    {!! Form::open(["method" => "DELETE", "route" => ["enclos.destroy", "enclo" => $enclos->id]]) !!}
                    {{ Form::button('<i class="fas fa-trash"></i>', ['type' => 'submit', 'class' => 'btn'] )  }}
                    {!! Form::close() !!}
                </td>
            </tr>
        </tbody>
    </table>

    <a href="{{ route('enclos.create') }}" class="btn btn-primary">Ajouter un enclos</a>
@endsection